package sig;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.security.GeneralSecurityException;
import java.security.cert.X509Certificate;
import sun.security.pkcs.PKCS7;  

public class SignApk {
	public static X509Certificate readSignatureBlock(InputStream in) throws IOException, GeneralSecurityException {
		PKCS7 pkcs7 = new PKCS7(in);
		return pkcs7.getCertificates()[0];
	}

	private static char[] toChars(byte[] mSignature) {
		byte[] sig = mSignature;
		final int N = sig.length;
		final int N2 = N * 2;
		char[] text = new char[N2];

		for (int j = 0; j < N; j++) {
			byte v = sig[j];
			int d = (v >> 4) & 0xf;
			text[j * 2] = (char) (d >= 10 ? ('a' + d - 10) : ('0' + d));
			d = v & 0xf;
			text[j * 2 + 1] = (char) (d >= 10 ? ('a' + d - 10) : ('0' + d));
		}
		return text;
	}
	
	public static String getSig(String sFileName) throws FileNotFoundException, IOException, GeneralSecurityException {
		if (sFileName.length() == 0) {  
            return "";  
        }  

		X509Certificate publicKey = readSignatureBlock(new FileInputStream(sFileName));	
		StringBuilder signature = new StringBuilder();
		signature.append(new String(toChars(publicKey.getEncoded())));
		
		return "Signature:" + MD5.toMD5(signature.toString()) + "|" + MD5.toMD5(publicKey.getEncoded());
	}
	
	public static void main(String[] args) throws FileNotFoundException, IOException, GeneralSecurityException {
		if (args.length == 0) {  
			System.out.println("请指定证书");  
			return;  
		}  
		
		X509Certificate publicKey = readSignatureBlock(new FileInputStream(new String(args[0])));	
		StringBuilder signature = new StringBuilder();
		signature.append(new String(toChars(publicKey.getEncoded())));
		
		System.out.println("Signature:" + MD5.toMD5(signature.toString()) + "|" + MD5.toMD5(publicKey.getEncoded()));
	}
}